#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#define BAUDRATE B38400
#define _POSIX_SOURCE 1 
#define FALSE 0
#define TRUE 1

//Variaveis Globais
int nr = 0, tamanho_fich = 0, tamanho=0,fim=0, check=0, nrejs=0;
FILE *fp;

//Prototipos de funcoes
int llopen(int fd);
int llread(int fd, char* result);
int llclose(int fd);
void limpar_buffer(int fd);


int main(int argc, char** argv)
{
    int fd;
    struct termios oldtio,newtio;

    if ( (argc < 2) || 
  	     ((strcmp("/dev/ttyS0", argv[1])!=0) && 
  	      (strcmp("/dev/ttyS1", argv[1])!=0) )) {
      printf("Usage:\tnserial SerialPort\n\tex: nserial /dev/ttyS1\n");
      exit(1);
    }

  /*
    Open serial port device for reading and writing and not as controlling tty
    because we don't want to get killed if linenoise sends CTRL-C.
  */
  
    fd = open(argv[1], O_RDWR | O_NOCTTY );
    if (fd <0) {perror(argv[1]); exit(-1); }

    if ( tcgetattr(fd,&oldtio) == -1) { /* save current port settings */
      perror("tcgetattr");
      exit(-1);
    }

    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;

    /* set input mode (non-canonical, no echo,...) */
    newtio.c_lflag = 0;

    newtio.c_cc[VTIME]    = 1;   /* inter-character timer unused */
    newtio.c_cc[VMIN]     = 0;   

  /* 
    VTIME e VMIN devem ser alterados de forma a proteger com um temporizador a 
    leitura do(s) proximo(s) caracter(es)
  */

    tcflush(fd, TCIOFLUSH);

    if ( tcsetattr(fd,TCSANOW,&newtio) == -1) {
      perror("tcsetattr");
      exit(-1);
    }

    printf("New termios structure set\n");
   

  /* 
    O ciclo WHILE deve ser alterado de modo a respeitar o indicado no guiao 
  */	

  /*
   *	As alterações ao código inicial fornecido começam aqui
   */

	printf("A iniciar transferencia..\n");

	int numero = 0;		//numero das tramas recebidas
	char buffer[256];	//array com informação do ficheiro

	llopen(fd);

	while(1)
	{
	
		int tam=0;	//tamanho de caracteres uteis lido da trama recebida 
		
		tam = llread(fd,buffer);
	
		int i;
	
		if(buffer[0] == 0)	//Campo de controlo indica que é uma trama de informaçao (Trama I)
		{
		
			int k = buffer[2]*256+buffer[3]; // calculo do tamanho recebido na trama atraves do seu conteudo (256*L2 + L1 = K)

			numero++;	//incrementa numero de trama
			printf("Recebida trama numero %d\n", numero);

			char buffer1[k], final[k];
			bzero(final,sizeof(final));
			bzero(buffer1,sizeof(buffer1));

			for(i=4; i < tam;i++)	//retira os 3 primeiros caracteres da trama (nao contem informacao)
				buffer1[i-4] = buffer[i];
		
			int temp = tam-4;
			tamanho_fich += tam-4;	//actualizacao do tamanho recebido
		
			for(i=0; i < tam-4; i++) 
				final[i] = buffer1[i];

			if(tamanho_fich + temp > tamanho) 
			{
				char temp1[tamanho - tamanho_fich+temp];	//restringe tamanho da trama ao numero de elementos estritamente necessario
				bzero(temp1, sizeof(temp1));
				int h;
				for(h=0; h < tamanho - tamanho_fich+temp; h++)
					temp1[h] = buffer1[h];
			
			
				if(check==1)	//verifica se e a ultima trama porque o tamanho a escrever no ficheiro sera menor
				{
					fim=1;
					fwrite (temp1 , 1 , (tamanho - tamanho_fich+temp) , fp );
				}
				check++;					
			}
			
			
			if(tamanho_fich > tamanho)
				tamanho_fich = tamanho;	
			printf("Tamanho Actual / Tamanho Total : %d/%d\n", tamanho_fich, tamanho);
		
			//Calculo da percentagem
			float t1 = (float) (tamanho_fich);
			float t2 = (float) (tamanho);
			float div = t1/t2;
			printf("%.2f%s\n", 100*div, "%");

			if(div==1)
				printf("Transferencia concluida\nForam enviados %d REJ\n", nrejs);
					
			if(fim==0)
				fwrite (final , 1 , temp , fp );	//escreve qualquer trama, excepto a ultima	
		}
		else if(buffer[0] == 1)	//Campo de controlo indica que é uma trama de START
		{
			char tam [10];
			bzero(tam,10);
			for(i=0; i < buffer[2]; i++)	//obtem o valor do tamanho, concatenando todos os caracteres no array
				tam[i] = buffer[i+3];

			tamanho = atoi(tam);	//obtem o valor inteiro a partir dos caracteres concatenados

			int k=i+3;
			char nome[buffer[k+1]];
			int m=k;
			k++;

			for(i=0; i < buffer[k]+1; m++,i++)	//Obtem o nome do ficheiro a ser criado
				nome[i] = buffer[m+2];
		
			unsigned int z;
			printf("Nome do ficheiro: ");
			for(z=0; z < sizeof(nome); z++)
				printf("%c", nome[z]);
			printf("\n");

			//criar ficheiro
			fp = fopen(nome, "a");		 
		}
	
		else if(buffer[0] == 2)	//Campo de controlo indica que é uma trama de END
		{
			fclose(fp);
			break;
		}
		else
		{
			printf("Erro ao receber a trama numero %d!\n", numero);	
			//Envia trama REJ se o campo de controlo nao for nenhum dos especificados anteriormente
			int rej = 0;
			if(nr == 0)
				rej = 0x05;
			else
				rej = 0x25;
	
			char REJ[5];

			REJ[0] = 0x7E;
			REJ[1] = 0x03;
			REJ[2] = rej;
			REJ[3] = REJ[2] ^ REJ[1];
			REJ[4] = 0x7E;				

			write(fd,REJ,5);
			nrejs++;
			printf("Enviei REJ numero %d com nr = %d\n", nrejs, nr);
		}
		printf("\n\n");
		bzero(buffer, sizeof(buffer));	
	}

    llclose(fd);

   /*
    *	As alterações ao código inicial fornecido acabam aqui
    */

    tcsetattr(fd,TCSANOW,&oldtio);
    close(fd);
    return 0;
}

//Funcao para apagar os valores indesejados lidos da porta de serie
void limpar_buffer(int fd)
{
	char temp;
	int lidos = -1;
	do{
		lidos = read(fd,&temp,1);
	}while(lidos != 0);
}

//Funcao que estabelece a ligacao atraves da porta de serie
int llopen(int fd)
{
	char buf[1],final[3];
	int estado = 0, res;
	bzero(final,3);
	buf[0]='\0';

	while (estado!=3) 
	{       
		res = read(fd, buf, 1);  //le um caracter 
		if(res > 0)
		{
			//verifica se o caracter = 7E
			if(estado == 0)
			{	
				if(buf[0] ==  0x7E)				
					estado = 1;
			}
			//verifica o campo de endereço
			if(estado == 1)
			{
				if(buf[0] ==  0x03)
					estado = 2;					
				else
					sprintf(final,"%s%s",final,buf);
			}
			if(estado == 2)
			{
					
				if(buf[0] !=  0x7E)
					sprintf(final,"%s%s",final,buf);
				else
				{
					sprintf(final,"%s%s",final,buf);
					char componente = final[1] ^ final[2];	//Verifica BCC1
					if(final[3] == componente) 
					{
						//verificar C(Byte controlo) e envia UA
						if(final[2] == 0x03)	//se for SET
						{
							printf("Recebi um SET\n");
							char UA[5];
							UA[0] = 0x7E;
							UA[1] = 0x03;
							UA[2] = 0x07;
							UA[3] = UA[2] ^ UA[1];
							UA[4] = 0x7E;
							write(fd,UA,strlen(UA)*sizeof(char)+1);
							printf("Enviei um UA\n");
							
						}
						estado = 3;	//termina ciclo
					}
					else estado=0;					
				}
			}
		}
		
	}
	limpar_buffer(fd);
 	return 1;
}

//Funcao que permite a terminacao controlada da transferencia
int llclose(int fd)
{
	int j=0;
	char buf[5];
	limpar_buffer(fd);

	while(j<5)	//le um caracter de cada vez
	{
		read(fd, buf, 5);
		j++;
	}
	
	limpar_buffer(fd);
	if((buf[0] == 0x7E) && (buf[1] == 0x03) && (buf[2] == 0x0B) &&	//verifica recepcao do comando DISC
	  (buf[3] == (buf[1]^buf[2])) && (buf[4] == 0x7E))
	{	
		printf("Recebi DISC!\n");
		char DISC[5];
		DISC[0] = 0x7E;
		DISC[1] = 0x03;
		DISC[2] = 0x0B;
		DISC[3] = DISC[2] ^ DISC[1];
		DISC[4] = 0x7E;
		limpar_buffer(fd);
		write(fd,DISC,5);	
		printf("Enviei DISC!\n");
	}
	limpar_buffer(fd);
	j=0;
	sleep(1);
	char buf4[5];
	while(j<5)
	{
		read(fd, buf4, 5);
		j++;
	}
	limpar_buffer(fd);
	
	if((buf4[0] == 0x7E) && (buf4[1] == 0x03) && (buf4[2] == 0x07) &&	//verifica recepcao do comando UA
	  (buf4[3] == (buf4[1]^buf4[2])) && (buf4[4] == 0x7E))
		printf("Recebi UA!\n");

 	return 1;
}


//Funcao que implementa o protocolo de transferencia de informacao
int llread(int fd, char* result)
{
	while(1)
	{
		int j=0;
		char buf[1],buffer[256];
		bzero(buffer, sizeof(buffer));
		while(j <256)
		{
			read(fd, buf, 1);	//le um caracter de cada vez
			if(buf[0] == 0x7e)	//encontra flag inicial
			{
				buffer[j]=buf[0];	//grava no array
				j++;
				while(j < 256)		//enquanto o tamanho for menor do que o estabelecido
				{
					read(fd, buf, 1);	//le novo elemento
			
					if(buf[0] == 0x7e)	//enquanto nao for flag de terminacao
					{
						buffer[j]=buf[0];	//grava no array
						break;
					}
					buffer[j]=buf[0];	//guarda ultima flag
					j++;
				}
				break;
			}
		
		}
	
		//Verifica bcc do header
		if(buffer[3] == (buffer[2]^buffer[1]))
		{
			unsigned int l=0, m=0, n=0,bufsize = 0;
			char buf2[sizeof(buffer)];
			bzero(buf2, sizeof(buf2));
			
			for(l=1; l < sizeof(buffer); l++) //retira flags do inicio e fim da trama
			{
				if(buffer[l] == 0x7e)
					break;
				else bufsize++;
			}
		
			bufsize-=2;
			
			for(m=3; m < sizeof(buffer); m++,n++)	//desfaz transparencia a partir do terceiro caracter
			{
				if(buffer[m] ==	0x7D && buffer[m+1] == 0x5E) //Transparencia para flag
				{					
					buf2[n] = 0x7E;					
					m++;
					bufsize--;				
				}
				else if(buffer[m] == 0x7D && buffer[m+1] == 0x5D) //Transparencia para escape
				{	
					buf2[n] = 0x7D;					
					m++;
					bufsize--;
				}				
				else
					buf2[n] = buffer[m];
			}

					
			int comp = buf2[1];
			//Calculo de BCC2
			for(m=2; m < bufsize-1;m++)
				comp = comp^buf2[m];

			char bcc2 = buf2[bufsize-1];
			buf2[bufsize-1]='\0';	//Apaga ultimo elemento
			buf2[bufsize-1]='\0';	//Apaga ultimo elemento
			bufsize-=2;
			buf2[0] = buffer[2];

			if(bcc2 == comp)
			{
				if((buf2[0]&0x02)>>1 == nr) //Ns=Nr
				{
					if(nr == 0)
						nr = 1;
					else 
						nr = 0;	
				}

				int rr = 0;
				if(nr == 0)
					rr = 0x01;
				else
					rr = 0x21;	

				char RR[5];
				RR[0] = 0x7E;
				RR[1] = 0x03;
				RR[2] = rr;
				RR[3] = RR[2] ^ RR[1];
				RR[4] = 0x7E;				

				write(fd,RR,5);
				int x;
				//Actualiza a variavel a devolver a camada da aplicacao
				for(x=0; x < 256; x++)
					result[x] = buf2[x+1];

				return bufsize;	//sucesso
			}
			else
			{		
				int rej = 0;
				if(nr == 0)
					rej = 0x05;
				else
					rej = 0x25;	
	
				char REJ[5];
	
				REJ[0] = 0x7E;
				REJ[1] = 0x03;
				REJ[2] = rej;
				REJ[3] = REJ[2] ^ REJ[1];
				REJ[4] = 0x7E;				

				write(fd,REJ,5);
				nrejs++;
				printf("Enviei REJ numero %d com nr = %d\n", nrejs, nr);
				sleep(2);			
			}
		}
	}
}

