/*Non-Canonical Input Processing*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


#define BAUDRATE B38400
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE	0
#define TRUE	1

#define SET	0x7e03007e
#define UA	0x7e03077e
#define FLAG	0x7e
#define FLAG2	0x7d

int alarme_activo = 0,	//varia entre o alarme de llopen e llwrite
	flag = 1,		//activa ou descativa alarme do llopen
	conta = 1,		//contador do numero de alarmes do llopen
	conta2 = 1,		//contador do numero de alarmes do llwrite
	terminar = 0,	//determina se llwrite terminou com erro ou nao
	terminar_tudo = 0,	//determina se llopen terminou com erro ou nao
	ns_local = 0,	//NS
	tam_i,		//tamanho das tramas de informacao
	num_max_retrans,	//numero maximo de retransmissoes
	time_out_length,	//intervalo de tempo do alarme
	num_t_retrans = 0,	//numero de tramas de informacao retransmitidas
	num_time_out = 0,	//numero de alarmes activados
	num_REJ_rec = 0,	//numero de REJ recebidos
	n_trama = 0;	//numero da trama I a enviar(N)

// atende alarme
void atende()
{
	if (alarme_activo == 0) {
		if (conta < 4) {
			printf("Alarme do llopen # %d\n", conta);	//imprime no maximo 3 alarmes
			flag = 1;					//reactiva a flag para permitir novo alarme
			conta++;
		}
		else
			terminar_tudo = 1;				//activa flag para terminar com erro
	}
	else {
		if (conta2 < 4) {
			printf("Alarme do llwrite # %d\n", conta2+1);	//imprime no maximo 3 alarmes
			conta2++;
		}
	}
}

//tira o lixo (caso haja) do buffer
void limpar_buffer(int fd) {
	char temp;
	int lidos = -1;

	do {
		lidos = read(fd, &temp, 1);				//le o que esta no buffer carater a carater...
	} while (lidos != 0);						//...ate ter apenas zeros
}

//estabelece ligação com o recetor
int llopen(int fd) {
	char buf[5];							//buffer que vai conter o SET
	bzero(buf, sizeof(buf));					//limpa o buffer do SET

	buf[0] = 0x7e;							//define...
	buf[1] = 0x03;
	buf[2] = 0x03;							//...o...
	buf[3] = buf[1] ^ buf[2];
	buf[4] = 0x7e;							//...SET

	printf("A estabelecer ligacao...\n");

	while(conta < 4)						//enquanto o numero de alarmes nao for 3
	{
		if(flag==1){
			alarm(3);					// activa alarme de 3s
			flag=0;
		}

		write(fd,buf,5);					//envia o SET para o recetor

		char final[5];						//buffer que vai conter o UA
		bzero(final, sizeof(final));				//limpa o buffer do UA

		read(fd, final, 6);					//le um UA
		limpar_buffer(fd);					//limpa o resto do buffer

		if(final[0] == 0)
			atende();					//se nao tiver lido nada, atende o alarme
		else
		{
			if (final[0] == 0x7e &&	final[1] == 0x03 &&
				final[2] == 0x07 &&	final[3] == (final[1] ^ final[2])
				&& final[4] == 0x7e) {

				printf("Ligacao Estabelecida (UA recebido)\n");	//se verificar que recebe um UA...
				conta = 4;						//...termina o ciclo de leitura com alarme
			}
			else {	return -1; }					//retorna -1 se terminar com erro desconhecido
		}
	}

	return 1;								//retorna 1 se terminar sem problemas
}

//termina a ligacao com o recetor
int llclose(int fd) {
	char buf[5];							//buffer que vai conter o DISC
	bzero(buf, sizeof(buf));					//limpa o buffer do DISC

	buf[0] = 0x7e;							//define...
	buf[1] = 0x03;
	buf[2] = 0x0B;							//...o...
	buf[3] = buf[1] ^ buf[2];
	buf[4] = 0x7e;							//..DISC

	limpar_buffer(fd);						//limpa o buffer para assegurar que nao enviara lixo
	write(fd,buf,5);						//envia o DISC

	char final[5];							//buffer que vai conter o DISC(recetor)
	bzero(final, sizeof(final));					//limpa o buffer que vai conter o DISC(recetor)
	sleep(1);
	read(fd, final, 5);						//le um DISC(recetor)

	printf("A desligar...\n");

	if (final[0] == 0x7e &&	final[1] == 0x03 &&
		final[2] == 0x0B &&	final[3] == (final[1] ^ final[2])
		&& final[4] == 0x7e) {

		buf[2] = 0x07;						//se recebe um DISC(recetor)...
		buf[3] = buf[1] ^ buf[2];				//...muda o DISC para um UA

		sleep(1);
		printf("A confirmar encerramento...(a enviar UA)\n");
		write(fd,buf,5);					//manda um UA
	}
	else
		return -1;						//retorna -1 se terminar com erro desconhecido

	return 1;							//retorna 1 se terminar sem problemas
}

//calcula bcc2 para as tramas
char calcular_bcc2(char dados[], int tamanho) {
	char bcc2 = dados[0];

	int k;
	for (k = 1; k != tamanho; k++) {
		bcc2 ^= dados[k];					//faz um "ou-exclusivo" de todos os bits da trama
	}

	return bcc2;
}

//estrutura para calcular transparencia
typedef struct {
	char* buf;							//buffer com transparencia
	int contador;							//novo tamanho de buf
} teste;

teste* calcular_transparencia(char dados[], int tamanho) {
	char* destino = malloc(2*tamanho);

	bzero(destino, 2*tamanho);

	char* limite_destino = destino;
	int k = 0;
	int contador = 0;

	for (k = 0; k != tamanho; k++) {
		if (dados[k] == FLAG) {					//se encontra uma FLAG...
			*limite_destino = 0x7d;				//...aplica-lhe a transparencia...
			limite_destino++;				//...e avança com o apontador
			contador++;
			*limite_destino = 0x5e;
		}
		else if (dados[k] == 0x7d) {				//se encontra um ESC...
			*limite_destino = 0x7d;				//...aplica-lhe a transparencia...
			limite_destino++;				//...e avança com o apontador
			contador++;
			*limite_destino = 0x5d;
		}
		else
			*limite_destino = dados[k];			//senao copia
		limite_destino++;
		contador++;
	}

	teste* return_type = malloc(sizeof(teste));

	return_type->buf = destino;
	return_type->contador = contador;

	return return_type;
}

//determina se recebe um RR ou um REJ
int* processar_resposta(char *buf) {

	int* devolver = malloc(2*sizeof(int));
	bzero(devolver, 2*sizeof(int));


	if (buf[0] != FLAG)						//se receber lixo, termina
		return devolver;

	char bbc1 = buf[1] ^ buf[2];					//calcula bcc1 da trama recebida...


	if (bbc1 == buf[3]) {						//...e verifica
		int mascara = 0x7;
		if ((buf[2] & mascara) == 1) // RR			//se os 3 primeiros bits tiverem o valor 1
		{
			devolver[0] = 1;				//devolve esse valor
			devolver[1] = (buf[2] >> 5);
		}
		else if ((buf[2] & mascara) == 5) // REJ		//se os 3 primeiros bits tiverem o valor 5
		{
			devolver[0] = 2;
			devolver[1] = (buf[2] >> 5);
		}
	}
	return devolver;
}

//calcula campo de controlo das tramas
char calcular_C(void) {
	if (ns_local == 0)
		return 0x00;
	else if (ns_local == 1)
		return 0x02;
	else {
		printf("Erro ao calcular o C\n");
		return -1;
	}
}

//envia pacotes de dados ao recetor
int llwrite(int fd,char* buf, int sizebuf){

	char buf_sem_trans[256];
	bzero(buf_sem_trans, sizeof(buf_sem_trans));

	buf_sem_trans[0] = FLAG;								//FLAG de inicio de pacote
	buf_sem_trans[1] = 0x03;								//A
	buf_sem_trans[2] = calcular_C();						//Campo de controlo
	buf_sem_trans[3] = buf_sem_trans[1] ^ buf_sem_trans[2];	//BCC1

	char bcc2 = calcular_bcc2(buf, sizebuf);				//BCC2 (necessario calcular sem a transparencia aplicada)

	char buf2[sizebuf+4];									//buffer auxiliar...
	bzero(buf2, sizebuf+4);

	int k;
	for (k = 0; k != sizebuf; k++) {
		buf2[k] = buf[k];
	}

	*(buf2+sizebuf) = bcc2;

	teste* buf_trans = calcular_transparencia(buf2, sizebuf+1);	//...para calcular e aplicar a transparencia

	char *temp = buf_trans->buf;


	for (k = 4; k != buf_trans->contador+4; temp++) {
		buf_sem_trans[k] = *temp;								//passa a informação com transparencia para o buffer a enviar(inclui BCC2)
		k++;
	}

	buf_sem_trans[k] = FLAG;									//finaliza o buffer a enviar com a FLAG


	free(buf_trans);											//desfaz-se do buffer auxiliar com a transparencia

	// Processar confirmacao
	char final[256];
	int mm;

	conta2 = 0;													//inicializa o contador de alarme do llwrite
	alarme_activo=1;											//muda o alarme de llopen para llwrite
	int* valores = 0;
	int contador_erro = 0,										//contador de erros(REJ & NS==NR)
		volta = 1;												//flag para saber se deve renviar a trma

	do {
		write(fd, buf_sem_trans, sizeof(buf_sem_trans));		//envia pacote ao recetor

		if(volta == 1)
		{
			alarm(time_out_length);								//activa o alarme
			mm = read(fd, final, 5);							//le a resposta
			if(mm > 0){											//se a resposta nao for nula..
				alarm(0);										//..desativa o alarme..
				limpar_buffer(fd);								//..limpa o resto do buffer..
				volta = 0;										//..e indica que a trama nao deve ser reenviada(temp)

				valores = processar_resposta(final);			//verifica o que recebeu(RR ou REJ?)

				if (valores[0] == 2) {							//se recebeu REJ..
					printf("Recebi REJ com valor: %d\n", valores[1]);
					printf("A reenviar a trama: ");
					num_t_retrans++;
					num_REJ_rec++;
					contador_erro++;
					volta = 1;									//..indica que deve reenviar a trama
				}

				if (valores[0] == 1) {							//se recebeu RR
					if (valores[1] == ns_local) {				//se este for igual ao NS(erro)..
						printf("Recebi um RR com NR == NS\n");
						bzero(final, sizeof(final));			//..limpa o buffer com a resposta..
						contador_erro++;
						volta = 1;								//..e indica que deve reenviar a trama
					}
					else {
						//ns_local = (ns_local + 1) % 2;			//senao actualiza NS
						free(valores);							//liberta a variavel com a resposta processada
						bzero(final, sizeof(final));			//limpa o buffer com a resposta

						return 1;								//retorna sucesso
					}
				}


				free(valores);
			}
			else
			{
				sleep(time_out_length-1);						//assegura que espera tempo suficiente para dar o alarme
				atende();										//assegura que atende o alarme
				num_time_out++;
				bzero(final, sizeof(final));					//limpa o buffer com a resposta

				volta = 1;										//indica que deve reenviar a trama
				contador_erro = 0;
			}
		}
	} while (contador_erro < num_max_retrans && conta2 < num_max_retrans);	//tenta no maximo 3 vezes, por alarme ou por erros

	printf("Rejeitado 3 vezes, a desistir\n");					//se sair do ciclo, llwrite termina com erro
	terminar = 1;												//indica ao programa para terminar com erro
	return 0;
}

//envia trama inicial para definir a informação a enviar
int mandar_start(int fd, char* filename, int size_file) {

	char* tamanho_string = malloc(10);
	sprintf(tamanho_string, "%d", size_file);

	int sizestr_tamanho = strlen(tamanho_string);
	int sizestr_nome = strlen(filename);


	char* trama_start = malloc(40);

	trama_start[0] = 0x1;										//tipo de trama
	trama_start[1] = 0x0;										//tipo de dados seguinte(tamanho do ficheiro)
	trama_start[2] = sizestr_tamanho;							//tamanho em octetos do tamanho do ficheiro
	strcpy(&trama_start[3], tamanho_string);					//tamanho do ficheiro
	trama_start[3+sizestr_tamanho] = 0x1;						//tipo de dados seguinte(nome do ficheiro)
	trama_start[3+sizestr_tamanho+1] = sizestr_nome;			//tamanho em octetos do nome do ficheiro
	strcpy(&trama_start[3+sizestr_tamanho+2], filename);		//nome do ficheiro

	llwrite(fd, trama_start, 3+sizestr_tamanho+2+sizestr_nome);	//envia trama ao recetor

	return 0;
}

//envia tramas de informação
void mandar_tramaI(int fd, char* buf, int sizebuf){

	char *tramaI = malloc(4+sizebuf);

	tramaI[0] = 0x0;											//Campo controlo = 0 significa dados
	tramaI[1] = n_trama;										//numero da trama a enviar
	n_trama = (n_trama + 1) % 256;								//atualiza o numero da trama

	tramaI[2] = sizebuf >> 8;									//numero de octetos do campo de dados(L2)
	tramaI[3] = sizebuf & 0xFF;									//numero de octetos do campo de dados(L1)

	int k = 0;
	for (k = 0; k != sizebuf; k++)
		tramaI[k+4] = buf[k];									//coloca os dados na trama

	llwrite(fd, tramaI, sizebuf+4);								//envia a trama

	free(tramaI);												//liberta o espaco ocupado
}

//envia trama final
void mandar_end(int fd) {
	char buffer3[7] = {2, 'c', FLAG, 'e', 'f', FLAG2, 0};		//apenas e necessario definir que C = 2

	llwrite(fd, buffer3, sizeof(buffer3));

	printf("End enviado\n");
}

int main(int argc, char** argv)
{
	int fd;
	struct termios oldtio,newtio;

	if ( (argc < 3) ||
		 ((strcmp("/dev/ttyS0", argv[1])!=0) &&
		  (strcmp("/dev/ttyS1", argv[1])!=0) )) {
		printf("Usage:\tnserial SerialPort filename\n\tex: nserial /dev/ttyS1 pinguim.gif\n");
		exit(1);
	}


	/*
	  Open serial port device for reading and writing and not as controlling tty
	  because we don't want to get killed if linenoise sends CTRL-C.
	*/


	fd = open(argv[1], O_RDWR | O_NOCTTY );
	if (fd <0) {perror(argv[1]); exit(-1); }

	if ( tcgetattr(fd,&oldtio) == -1) { /* save current port settings */
		perror("tcgetattr");
		exit(-1);
	}

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;

	/* set input mode (non-canonical, no echo,...) */
	newtio.c_lflag = 0;

	newtio.c_cc[VTIME]	  = 1;	 /* inter-character timer unused */
	newtio.c_cc[VMIN]	  = 0;	 /* blocking read until 5 chars received */



	/*
	   VTIME e VMIN devem ser alterados de forma a proteger com um temporizador a
	   leitura do(s) pr�ximo(s) caracter(es)
	*/



	tcflush(fd, TCIOFLUSH);

	if ( tcsetattr(fd,TCSANOW,&newtio) == -1) {
		perror("tcsetattr");
		exit(-1);
	}

	(void) signal(SIGALRM, atende);								//handler do alarme

	llopen(fd);													//abre a ligacao

	if(terminar_tudo == 1)										//verifica se llopen terminou com erro
		return 0;

	/*
	   O ciclo FOR e as instru��es seguintes devem ser alterados de modo a respeitar
	   o indicado no gui�o
	*/


	char erro[7] = {6, 'f', FLAG, 'r', 7, FLAG2, 5};			//buffer para simular erros

	// Logica de aplicacao

	char *nome = argv[2];

	FILE* ficheiro_enviar = fopen(nome, "rb");					//abre o ficheiro passado pelo utilizador

	if (ficheiro_enviar == NULL) {								//verifica se o nome do ficheiro foi passado
		printf("Ficheiro \"%s\" nao existe\n", nome);
		printf("Numero tramas retransmitidas = %d\nNumero de time outs = %d\nNumero de REJs recebidos = %d\n", num_t_retrans, num_time_out, num_REJ_rec);
		return -1;
	}

	struct stat st;
	stat(nome, &st);
	int tamanho_ficheiro = st.st_size;

	//dados a ser introduzidos pelo utilizador
	do{
		printf("Escolha o tamanho máximo das tramas de informação (2 - 127): ");
		scanf ("%d",&tam_i);
	}while(tam_i < 2 || tam_i > 127);

	do{
		printf("Escolha o numero maximo de retransmissões (se não tiver a certeza, escreva 3): ");
		scanf ("%d",&num_max_retrans);
	}while(num_max_retrans < 0);

	do{
		printf("Escolha o intervalo de time-out (se não tiver a certeza, escreva 3): ");
		scanf ("%d",&time_out_length);
	}while(time_out_length < 0);

	mandar_start(fd, nome, tamanho_ficheiro);					//envia trama inicial
	limpar_buffer(fd);											//limpa o buffer

	char* bufferI = malloc(tam_i);
	char* aux = malloc(tam_i);

	srand(time(NULL));
	int numerot = 1;											//variavel para identificar o numero da trama
	int numerot2  = (int)(rand()%20);											//variavel para simulacao de erros
	while (tam_i*numerot < tamanho_ficheiro+tam_i) {
		if(numerot2 == 20)										//simulacao de erros
		{
			printf("Enviando trama com erro!\n");
			llwrite(fd, erro, 7);
			num_t_retrans++;
			num_REJ_rec++;
			numerot2=(int)(rand()%20);
			aux = bufferI;
		}
		else
		{
			fread(bufferI, 1, tam_i, ficheiro_enviar);			//le do ficheiro
			mandar_tramaI(fd, bufferI, tam_i);					//envia trama lida

			printf("Enviando trama numero: %i\n", numerot);
			limpar_buffer(fd);
			numerot++;
			numerot2++;

			if(terminar == 1){									//verifica se termina com erro
				printf("A terminar(erro)...\n");
				printf("Numero tramas retransmitidas = %d\nNumero de time outs = %d\nNumero de REJs recebidos = %d\n", num_t_retrans, num_time_out, num_REJ_rec);
				return 0;
			}
		}
		if(tam_i*numerot == tamanho_ficheiro)					//verifica se as tramas enviadas equivalem ao tamanho do ficheiro
			break;
	}

	printf("A escrever END\n");
	mandar_end(fd);												//envia trama final

	llclose(fd);												//fecha a aplicacao
	// Termina a logica da aplicacao

	if ( tcsetattr(fd,TCSANOW,&oldtio) == -1) {
		perror("tcsetattr");
		exit(-1);
	}

	printf("Confirmado!\nA fechar a aplicacao...\n");

	printf("\nEstatísticas:\nNumero tramas retransmitidas = %d\nNumero de time outs = %d\nNumero de REJs recebidos = %d\n", num_t_retrans, num_time_out, num_REJ_rec);

	close(fd);
	return 0;
}

